import { ModelInterface } from '../index';
import Model from './model';
export interface PreferenceModel extends ModelInterface {
    between(start: string, end: string): this;
    next(): this;
    on(day: number): this;
    transform(): object;
}
export interface PreferenceParameters {
    day?: number | null;
    end?: string | null;
    start?: string | null;
    type?: number | null;
}
export default class Preference extends Model implements PreferenceModel {
    static now(): string;
    protected attributes: PreferenceParameters;
    constructor();
    between(start: string, end: string): this;
    next(): this;
    on(day: number): this;
    transform(): object;
    static readonly NEXT_AVAILABLE: number;
    static readonly CERTAIN_DAYS: number;
}
